<?php
/**
 * Extract an extension package remove root folder.
 *
 * @param  string    $extension
 * @access public
 * @return object
 */
public function extractPackage($extension)
{
    $return = new stdclass();
    $return->result = 'ok';
    $return->error  = '';

    /* try remove pre extracted files. */
    $extensionPath = "ext/$extension";
    if(is_dir($extensionPath)) $this->classFile->removeDir($extensionPath);

    /* Extract files. */
    $packageFile = $this->getPackageFile($extension);
    $this->app->loadClass('pclzip', true);
    $zip = new pclzip($packageFile);
    $files = $zip->listContent();
    // Remove root folder
    $removePath = substr($files[0]['filename'], 0, strpos($files[0]['filename'], '/'));
    // $return->result = $return->error = $removePath . json_encode($files);
    if($zip->extract(PCLZIP_OPT_PATH, $extensionPath, PCLZIP_OPT_REMOVE_PATH, $removePath) == 0)
    {
        $return->result = 'fail';
        $return->error  = $zip->errorInfo(true);
    }

    return $return;
}